/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include <string.h>
#include <errno.h>
#include <stdlib.h>

#define DEBUG 0
#include "debug.h"

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#define min(x,y)	((x) < (y) ? (x):(y))

GtkWidget *window = NULL;
GdkColormap *cmap;
GtkWidget *da = NULL;
GtkWidget *progressbar = NULL;
GdkGC *da_gc = NULL;
GdkPixmap *image = NULL;
GdkGC *image_gc = NULL;
int width = 400;
int height = 300;
int line_width = 1;

int draw(char *cmd) {
	char *kw = NULL;
	GdkColor c;
	GdkRectangle update_rect;
	int x1 = 0, y1 = 0, x2 = 0, y2 = 0, w = 0, h = 0;
	int r = 0, g = 0, b = 0;
	float a1 = 0., a2 = 0.;
	int do_update = 0;


	/* get keyword */
	kw = cmd;
	if ((cmd = strchr(cmd, 0x20))) {
		*cmd++ = 0;
	} else {
		cmd = "";
	}

	DBG_MSG(3, "kw: \"%s\", args: \"%s\"", kw, cmd);

	/* neni to moc hezke, ale je to jednoduche :) */
	if (strcmp(kw, "draw_line") == 0) {
		if (sscanf(cmd, "%d %d %d %d", &x1, &y1, &x2, &y2) == 4) {
			DBG_MSG(2, "drawing line(%d, %d, %d, %d)", x1, y1, x2, y2);
			gdk_draw_line(image, image_gc, x1, y1, x2, y2);
			w = abs(x2 - x1);
			h = abs(y2 - y1);
			x1 = min(x1, x2);
			y1 = min(y1, y2);
			do_update = 1;
		} else {
			fprintf(stderr, "Wrong arguments for 'draw_line'\n");
		}

	} else if (strcmp(kw, "draw_rect") == 0) {
		if (sscanf(cmd, "%d %d %d %d", &x1, &y1, &w, &h) == 4) {
			DBG_MSG(2, "drawing rectangle(%d, %d, %d, %d)", x1, y1, w, h);
			gdk_draw_rectangle(image, image_gc, FALSE, x1, y1, w, h);
			do_update = 1;
		} else {
			fprintf(stderr, "Wrong arguments for 'draw_rect'\n");
		}

	} else if (strcmp(kw, "draw_rect_f") == 0) {
		if (sscanf(cmd, "%d %d %d %d", &x1, &y1, &w, &h) == 4) {
			DBG_MSG(2, "drawing filled rectangle(%d, %d, %d, %d)", x1, y1, w, h);
			gdk_draw_rectangle(image, image_gc, TRUE, x1, y1, w, h);
			do_update = 1;
		} else {
			fprintf(stderr, "Wrong arguments for 'draw_rect_f'\n");
		}

	} else if (strcmp(kw, "draw_arc") == 0) {
		if (sscanf(cmd, "%d %d %d %d %f %f", &x1, &y1, &w, &h, &a1, &a2) == 6) {
			DBG_MSG(2, "drawing arc(%d, %d, %d, %d, %f, %f)", x1, y1, w, h, a1, a2);
			gdk_draw_arc(image, image_gc, FALSE, x1, y1, w, h, (int)(a1 * 64), (int)(a2 * 64));
			do_update = 1;
		} else {
			fprintf(stderr, "Wrong arguments for 'draw_arc'\n");
		}

	} else if (strcmp(kw, "draw_arc_f") == 0) {
		if (sscanf(cmd, "%d %d %d %d %f %f", &x1, &y1, &w, &h, &a1, &a2) == 6) {
			DBG_MSG(2, "drawing filled arc(%d, %d, %d, %d, %f, %f)", x1, y1, w, h, a1, a2);
			gdk_draw_arc(image, image_gc, TRUE, x1, y1, w, h, (int)(a1 * 64), (int)(a2 * 64));
			do_update = 1;
		} else {
			fprintf(stderr, "Wrong arguments for 'draw_arc_f'\n");
		}

	} else if (strcmp(kw, "set_color") == 0) {
		if (sscanf(cmd, "%d %d %d", &r, &g, &b) == 3) {
			c.red = r; c.green = g; c.blue = b;
			DBG_MSG(2, "selecting color (%d, %d, %d)", c.red, c.green, c.blue);
			gdk_gc_set_rgb_fg_color (image_gc, &c);
		} else {
			fprintf(stderr, "Wrong arguments for 'color'\n");
		}

	} else if (strcmp(kw, "set_line_width") == 0) {
		if (sscanf(cmd, "%d", &x1) == 1) {
			DBG_MSG(2, "setting line width (%d)", x1);
			gdk_gc_set_line_attributes (image_gc, x1, GDK_LINE_SOLID, GDK_CAP_ROUND, GDK_JOIN_ROUND);
			line_width = x1;
		} else {
			fprintf(stderr, "Wrong arguments for 'line_width'\n");
		}

	} else if (strcmp(kw, "clear") == 0) {
		c.red = c.green = c.blue = 65535;
		gdk_gc_set_rgb_fg_color (image_gc, &c);
		gdk_draw_rectangle(image, image_gc, TRUE, 0, 0, width, height);
		c.red = c.green = c.blue = 0;
		gdk_gc_set_rgb_fg_color (image_gc, &c);
		x1 = 0; y1 = 0;
		w = width; h = height;
		do_update = 1;

	} else if (strcmp(kw, "progressbar_hide") == 0) {
		gtk_widget_hide(progressbar);

	} else if (strcmp(kw, "progressbar_show") == 0) {
		gtk_widget_show(progressbar);

	} else if (strcmp(kw, "progressbar_text") == 0) {
		gtk_progress_bar_set_text(GTK_PROGRESS_BAR(progressbar), cmd);

	} else if (strcmp(kw, "progressbar_position") == 0) {
		if (sscanf(cmd, "%f", &a1) == 1) {
			gtk_progress_bar_set_fraction(GTK_PROGRESS_BAR(progressbar), a1 / 100.0);
			gtk_main_iteration_do(FALSE);
		} else {
			fprintf(stderr, "Wrong arguments for 'progressbar_position'\n");
		}

	} else if (strcmp(kw, "set_windowtitle") == 0) {
		gtk_window_set_title(GTK_WINDOW(window), cmd);

	} else if (strcmp(kw, "set_size") == 0) {
		if (sscanf(cmd, "%d %d", &w, &h) == 2) {
			width = w; height = h;
			gtk_window_resize(GTK_WINDOW(window), width, height);
			gtk_widget_set_size_request(da, width, height);
			gdk_pixmap_unref(image);
			image = gdk_pixmap_new(da->window, width, height, -1);
		}
	
	} else if (strcmp(kw, "set_fullscreen") == 0) {
		if (sscanf(cmd, "%d", &x1) == 1) {
			DBG_MSG(2, "setting fullscreen (%d)", x1);
			if (x1)
				gtk_window_fullscreen(GTK_WINDOW(window));
			else
				gtk_window_unfullscreen(GTK_WINDOW(window));
		} else {
			fprintf(stderr, "Wrong arguments for 'line_width'\n");
		}

	} else if (strcmp(kw, "exit") == 0) {
		gtk_main_quit();
	} else if (kw[0] != 0 && kw[0] != '#') {
		fprintf(stderr, "unknown command \"%s\"\n", kw);
	}

	if (do_update) {
		/* Now invalidate the affected region of the drawing area. */
		DBG_MSG(2, "Requested to update rectangle at [ %d, %d ],  %d x %d", x1, y1, w, h);
		
		update_rect.x = x1 - line_width - 2;
		if (update_rect.x < 0)
			update_rect.x = 0;

		update_rect.y = y1 - line_width - 2;
		if (update_rect.y < 0)
			update_rect.y = 0;

		update_rect.width = w + 2 * line_width + 4;
		if (update_rect.width + update_rect.x > width || update_rect.width < 0)
			update_rect.width = width - update_rect.x;

		update_rect.height = h + 2 * line_width + 4;
		if (update_rect.height + update_rect.y > height || update_rect.height < 0)
			update_rect.height = height - update_rect.y;

		DBG_MSG(2, "Updating rectangle at [ %d, %d ],  %d x %d",
				update_rect.x, update_rect.y,
				update_rect.width, update_rect.height);

		gdk_window_invalidate_rect(da->window, &update_rect, TRUE);
	}
	return 0;
}

gboolean on_stdin_callback (	GIOChannel *source, 
				GIOCondition condition, 
				gpointer data)
{
	gchar *p_msg;

	GIOStatus ret;
	GError *err = NULL;
	gchar *msg;
	gsize len;


	DBG_MSG(2, "Reading data...");

	if (condition & G_IO_IN) {
		ret = g_io_channel_read_line(source, &msg, &len, NULL, &err);
		if (len == 0) {
			DBG_MSG(2, "EOF.");
			return FALSE;
		}

		if (ret == G_IO_STATUS_ERROR) {
			g_error("Error reading: %s\n", err->message);
			return FALSE;
		}

		if ((p_msg = strchr(msg, '\n')))
			*p_msg = 0;
		draw(msg);

		g_free(msg);

		return TRUE;
	}
	return FALSE;
}


int
main (int argc, char *argv[])
{
	GIOChannel *channel;
	GdkColor black;

#ifdef ENABLE_NLS
	bindtextdomain(GETTEXT_PACKAGE, PACKAGE_LOCALE_DIR);
	bind_textdomain_codeset(GETTEXT_PACKAGE, "UTF-8");
	textdomain(GETTEXT_PACKAGE);
#endif

	gtk_set_locale();
	gtk_init(&argc, &argv);

	add_pixmap_directory(PACKAGE_DATA_DIR "/" PACKAGE "/pixmaps");


	/* create window */
	window = create_window();
	gtk_widget_show(window);

	/* make margin black (for fullscreen) */
	black.red = black.green = black.blue = 0;
	gtk_widget_modify_bg(window, GTK_STATE_NORMAL, &black);

	/* init progressbar */
	progressbar = lookup_widget(window, "progressbar");

	/* get drawingarea */
	da = lookup_widget(window, "drawingarea");
	da_gc = gdk_gc_new(da->window);
	gtk_widget_set_size_request(da, width, height);

	/* create image */
	image = gdk_pixmap_new(da->window, width, height, -1);
	image_gc = gdk_gc_new(image);
	draw("clear");

	/* watch stdin */
	channel = g_io_channel_unix_new(0);
	g_io_add_watch(channel, G_IO_IN | G_IO_ERR | G_IO_HUP, on_stdin_callback, NULL);

	/* run */
	gtk_main();
	return 0;
}

