/*
 * main.c - fraktaly: 4 ctverce v sobe
 * 
 * Copyright (C) 2006  Josef Kufner <jk@myserver.cz>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <unistd.h>

#define DEBUG 0
#include "debug.h"

#define DELAY 1e4

void draw_squares(int level, int x, int y, int a) {
	int new_a = a * .33;

	/* velky ctverec */
	printf("set_line_width %d\n", level > 3 ? 1 : 3);
	printf("draw_rect %d %d %d %d\n", x, y, a, a);
	fflush(stdout);
	usleep(DELAY);

	/* 4 mensi uvnitr */
	if (level++ <= 5) {
		draw_squares(level, x + a * 1./4. - new_a / 2, y + a * 1./4. - new_a / 2, new_a);
		draw_squares(level, x + a * 3./4. - new_a / 2, y + a * 1./4. - new_a / 2, new_a);
		draw_squares(level, x + a * 1./4. - new_a / 2, y + a * 3./4. - new_a / 2, new_a);
		draw_squares(level, x + a * 3./4. - new_a / 2, y + a * 3./4. - new_a / 2, new_a);

		/*
		draw_squares(level, x +  0 + space, y +  0 + space, aa - 2 * space);
		draw_squares(level, x + aa + space, y +  0 + space, aa - 2 * space);
		draw_squares(level, x +  0 + space, y + aa + space, aa - 2 * space);
		draw_squares(level, x + aa + space, y + aa + space, aa - 2 * space);
		*/
	}

}

int main (void) {
	int size = 768;

	printf(
		"set_fullscreen 1\n"
		"set_windowtitle Fraktaly: 4 ctverce v sobe\n"
		"set_size %d %d\n"
		"set_line_width 3\n"
		"clear\n"
		"set_color 0 0 32768\n",
		size, size
	);
	fflush(stdout);

	draw_squares(1, 0, 0, size);

	return 0;
}

/* vim:set encoding=utf8: */
