/*
 * main.c - fraktaly: ctverce ven
 * 
 * Copyright (C) 2006  Josef Kufner <jk@myserver.cz>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <unistd.h>

#define DEBUG 0
#include "debug.h"

#define DELAY 2e3

enum { UP, LEFT, RIGHT, DOWN };

void draw_squares(int level, int x, int y, int r) {
	int new_r = r * 0.4;

	/* prostredni */
	printf("set_line_width %d\n", level > 3 ? 1 : 3);
	printf("draw_rect %d %d %d %d\n", x, y, r, r);
	fflush(stdout);
	usleep(DELAY);

	/* 3 okolo */
	if (level++ <= 5) {
		draw_squares(level, x + r / 2 - new_r/2, y - new_r, new_r);
		draw_squares(level, x + r / 2 - new_r/2, y + r, new_r);
		draw_squares(level, x - new_r, y + r / 2 - new_r / 2, new_r);
		draw_squares(level, x + r, y + r / 2 - new_r / 2, new_r);
	}

}

int main (void) {
	int size = 768;

	printf(
		"set_fullscreen 1\n"
		"set_windowtitle Fraktaly: ctverce\n"
		"set_size %d %d\n"
		"set_line_width 3\n"
		"clear\n"
		"set_color 0 0 32768\n",
		size, size
	);
	fflush(stdout);

	draw_squares(1, size/3, size/3, size/3);

	return 0;
}

/* vim:set encoding=utf8: */
