/*
 * main.c - fraktaly: ctverce ven
 * 
 * Copyright (C) 2006  Josef Kufner <jk@myserver.cz>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <unistd.h>

#define DEBUG 0
#include "debug.h"

#define DELAY 5e2

enum { UP, LEFT, RIGHT, DOWN };

void draw_squares(int level, int x, int y, int r) {
	float new_r = r / 3.;

	/* prostredni */
	printf("set_line_width %d\n", level > 3 ? 1 : 3);
	printf("draw_rect_f %d %d %d %d\n", (int)(x + new_r), (int)(y + new_r), (int) new_r, (int) new_r);
	fflush(stdout);
	usleep(DELAY);

	/* 3 okolo */
	if (level++ <= 4) {
		draw_squares(level, x + r * 0./3., y + r * 0./3., new_r);
		draw_squares(level, x + r * 1./3., y + r * 0./3., new_r);
		draw_squares(level, x + r * 2./3., y + r * 0./3., new_r);

		draw_squares(level, x + r * 0./3., y + r * 1./3., new_r);
		draw_squares(level, x + r * 2./3., y + r * 1./3., new_r);

		draw_squares(level, x + r * 0./3., y + r * 2./3., new_r);
		draw_squares(level, x + r * 1./3., y + r * 2./3., new_r);
		draw_squares(level, x + r * 2./3., y + r * 2./3., new_r);
	}

}

int main (void) {
	int size = 729;

	printf(
		"set_fullscreen 1\n"
		"set_windowtitle Fraktaly: Sierpinského kobereček\n"
		"set_size %d %d\n"
		"set_line_width 3\n"
		"clear\n"
		"set_color 0 0 32768\n",
		size, size
	);
	fflush(stdout);

	draw_squares(1, 0, 0, size);

	return 0;
}

/* vim:set encoding=utf8: */
