/*
 * main.c - fraktaly: kruhy
 * 
 * Copyright (C) 2006  Josef Kufner <jk@myserver.cz>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#include <stdio.h>
#include <unistd.h>

#define DEBUG 0
#include "debug.h"

#define DELAY 5e3

enum { UP, LEFT, RIGHT, DOWN };

void draw_circles(int level, int x, int y, int r, int orient) {
	int new_r = r / 2;

	/* prostredni */
	printf("draw_arc_f %d %d %d %d 0 360\n", x, y, r, r);
	fflush(stdout);
	usleep(DELAY);

	/* 3 okolo */
	if (level++ <= 7) {
		if (orient != DOWN)
			draw_circles(level, x + r / 2 - new_r/2, y - new_r, new_r, UP);
		if (orient != UP)
			draw_circles(level, x + r / 2 - new_r/2, y + r, new_r, DOWN);
		if (orient != RIGHT)
			draw_circles(level, x - new_r, y + r / 2 - new_r / 2, new_r, LEFT);
		if (orient != LEFT)
			draw_circles(level, x + r, y + r / 2 - new_r / 2, new_r, RIGHT);
	}

}

int main (void) {
	int size = 768;

	printf(
		"set_fullscreen 1\n"
		"set_windowtitle Fraktaly: 4 ctverce v sobe\n"
		"set_size %d %d\n"
		"set_line_width 3\n"
		"clear\n"
		"set_color 0 0 32768\n",
		size, size
	);
	fflush(stdout);

	draw_circles(1, size * 2./6., size * 3./6., size * 2./6., UP);

	return 0;
}

/* vim:set encoding=utf8: */
