/*
 * main.c - fraktaly: strom
 * 
 * Copyright (C) 2006  Josef Kufner <jk@myserver.cz>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#define __USE_SVID
#define __USE_GNU

#include <stdio.h>
#include <unistd.h>
#include <math.h>

#define DEBUG 0
#include "debug.h"

#define DELAY 5e4

enum { X, Y };

void draw_tree(int level, int x, int y, int size, int orient) {
	int new_size = size / 1.732;	/* sqrt(3) */
	int new_x, new_y;

	/*
	 * new_x = x - sin(orient) * size;
	 * new_y = y - cos(orient) * size;
	 */

	int orient_trans[2][8] = {
		/* X */ {  0,  1,  1,  1,  0, -1, -1, -1 },
		/* Y */ { -1, -1,  0,  1,  1,  1,  0, -1 }
	};

	new_x = x + orient_trans[X][orient] * size;
	new_y = y + orient_trans[Y][orient] * size;
	
	/* prostredni */
	printf("draw_line %d %d %d %d\n", x, y, new_x, new_y);
	fflush(stdout);
	usleep(DELAY);

	/* vetve */
	if (level++ <= 7) {
		draw_tree(level, new_x, new_y, new_size, (orient + 7) % 8);
		draw_tree(level, new_x, new_y, new_size, (orient + 1) % 8);
	}
}

int main (void) {
	int size = 768;

	printf(
		"set_fullscreen 1\n"
		"set_windowtitle Fraktaly: Strom\n"
		"set_size %d %d\n"
		"set_line_width 3\n"
		"clear\n"
		"set_color 0 32768 0\n",
		size, size
	);
	fflush(stdout);

	draw_tree(1, size / 2, size * 3./4., size / 4, 0);

	return 0;
}

/* vim:set encoding=utf8: */
